/*** ICMP monitor (C) 1999 by Stealth. Thanx to CyberPsychotic.
 *** Greetings to K.A.L.U.G. , CB and 29A.
 *** For educational purposes only!
 *** 
 *** Stealth	<stealth@gizmo.kyrnet.kg>
 ***/
#include "icmp.h"

#ifdef GPL_IN
extern char *COPYING;
#endif

int main(int argc, char **argv)
{
	int no_stdout = 0, 
            resolve = 0, seq = 0, 
	    echo = 1, what = MONITOR, to = 0, p = 0;
        char intf[11] = {0};
        char file[256] = {0};
        char c;

        signal(SIGINT, inthandler);
        opterr = 0;         
#ifdef GPL_IN
	while ((c = getopt(argc, argv, "i:o:l:rsdg")) != -1) {
#else
        while ((c = getopt(argc, argv, "i:o:l:rsd")) != -1) {
#endif
           	switch (c) {
                   	/* specify interface */
                   	case 'i':
                           	strncpy(intf, optarg, 10);
                                if (strstr(intf, "ppp")) {
                                   	fprintf(stderr, "Sorry, ppp is not supported yet.\n");
                                        exit(1);
                                }
                                break;
                        /* redirect output */
                        case 'o':
                           	strncpy(file, optarg, 255);
                                no_stdout++;
                                break;
                        /* resolve IP to hostname */
                        case 'r':
                           	resolve++;
                                break;
                        /* print out icmp_seq */
                        case 's':
                           	seq++;
                                break;
                        /* don't print out ECHO_REQUEST/REPLY */
                        case 'd':
                           	echo = 0;
                                break;
                        /* try to detect LOKI in LAN (passive) */
                        case 'l':
                           	what = LOKI_DETECT;
                                to = atoi(optarg);
				break;
#ifdef GPL_IN
                        /* give her the license */
			case 'g':
				puts(COPYING);
				exit(1);
				break;
#endif
                        default:
                           	help_her(argv[0]);
				/* never reached */
                                break;
                }
        }
        /* the defaultinterface */
        if (intf[0] == '\0')
           	strcpy(intf, DEVICE);
        if (no_stdout) {
           	if ((p = fork()) < 0) {
                   	perror("fork");
                        exit(errno);
                } else if (p > 0)
                   	exit(0);
                close(1);
                if (open(file, O_RDWR|O_APPEND|O_CREAT, 0640) != 1) {
                   	perror("open");
                        exit(errno);
                }
        }
                
        
        if (what == MONITOR)
		monitor(resolve, seq, echo, intf);
        if (what == LOKI_DETECT)
           	passive_loki(intf, to);
	return 0;
}

int 
setpromisc(int fd, const char *dev)
{
        strcpy(ifr.ifr_name, dev);
        if (ioctl(fd, SIOCGIFFLAGS, &ifr) < 0) {
                perror("ioctl");
                exit(errno);
        }
        ifr.ifr_flags |= IFF_PROMISC;
        if (ioctl(fd, SIOCSIFFLAGS, &ifr) < 0) {
                perror("ioctl");
                exit(errno);
        }
	printf("Successful set promisc mode on interface %s.\n", dev); 
	return 0;
}

int
droppromisc(int fd)
{
	if (!(ifr.ifr_flags & IFF_PROMISC))
		printf("Fatal: promisc mode was not set!\n");
        ifr.ifr_flags &= ~IFF_PROMISC;
        if (ioctl(fd, SIOCSIFFLAGS, &ifr) < 0) {
                perror("ioctl");
                exit(errno);
        }
	printf("Successful droped promisc mode.\n");
	return 0;
}

