/*** Part of the ICMP monitor. (C) 1999 by Stealth. Its under the GPL.
 ***
 ***/
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "icmp.h"

extern int promisc;

void
inthandler(int sig)
{
#ifdef REENTRANT
	printf("\nCaught signal %d (should be CTRL-C).\n", sig);
#endif
	if (promisc)
		droppromisc(promisc);
	/* we pushed the fd in promisc in main() */
	close(promisc);
	exit(0);
}

/* If the type or code is out of range the 'was' should be "" */
void
bounds_check(u_int8_t *type, u_int8_t *code)
{
   	if (*type >= NR_TYPE || *code >= NR_CODE) {
           	printf("badly formed ICMP packet (type=%d, code=%d)\n", *type, *code);
           	*type = 1;
                *code = 1;
        }
}

void
help_her(const char *s)
{
   	puts(we);
	fprintf(stderr, "\nusage:\n"
			" %s [-i intf] [-o file] [-r] [-s] [-d] [-g] [-l time]\n\n"
                        "     -i intf  -  use this interface\n"
                        "     -o file  -  force output to this file (daemon mode!)\n"
                        "     -r       -  resolve IP adresses to hostnames\n"
                        "     -s       -  tell the icmp_seq field (used by 'ping')\n"
			"     -d       -  drop ECHO_REQUEST/REPLY type\n"
			"     -l time  -  passive LOKI detect within 'time' seconds\n"
			"                 (100 gives a reliable result)\n"   
#ifdef GPL_IN
			"     -g       -  show the GPL.\n"
#endif
			"\n", s);
        exit(1);
}


/* if how == 0, only give back IP */
char*
resolv(struct in_addr in, int how)
{
	    char *s;
	    struct hostent *he;
	    
	    if ((s = (char*)malloc(500)) == NULL) {
		    perror("malloc");
		    exit(errno);
	    }
	    if (how == 0 || (he = gethostbyaddr((const char*)&in, sizeof(in), AF_INET)) == NULL) 
		    strncpy(s, inet_ntoa(in), 400);
	    else
		    strncpy(s, he->h_name, 400);
	    return s;
}
	
		    
		    
